---
title: Simple Flexdiam
---
import DocCardList from '@theme/DocCardList';

Simple Flexdiam is based on _Flexdiam_. It is a Dialog Manager that stores events in tiers and uses observers to handle these events.
The dialog flow is organised in Simple Flexdiam via a flow handler. At the moment, only the issue flow handler is implemented.

You need to specify the flow handler via the module_config (/arch_config). Further, the issue flow handler requires to specify the root issue and the shadow issues. The entry point finder needs also to be specified.

For example:
```yaml
  simple_flexdiam:
    module_info: !name:simple_flexdiam.modules.simple_flexdiam_module.SimpleFlexdiam
    flow_handler:
      flow_handler_class: !name:simple_flexdiam.modules.issue_flow_handler.issue_flow_handler.IssueFlowHandler
      root_issue: !name:simple_flexdiam.modules.std.issues.root_issue.RootIssue
      shadow_root_issues:
        - !name:simple_flexdiam.modules.std.issues.greet_issue.GreetIssue
        - !name:simple_flexdiam.modules.std.issues.how_are_you_issue.HowAreYouIssue
        - !name:simple_flexdiam.modules.std.issues.repeat_issue.RepeatIssue
      entry_point_finder: !name:simple_flexdiam.modules.issue_flow_handler.simple_entry_point_finder.SimpleEntryPointFinder
```

:::info
The NLU needs some time to start/load the tensorflow models. In this start-up time, it receives the ASR outputs but the NLU output is not generated yet. Which might lead to a huge set of answers after some seconds.
At the moment, the best way to go around it, is to be silent after the start of the architecture.

:::

### Installation
The other modules (basic tts, rasa_nlu, and vosk asr) already install simple flexdiam as a requirement. If you still want it to install you can either clone the repo and do `pip install -e .` Or:
```bash title="conda activate aaambos"
pip install simple_flexdiam@git+https://gitlab.ub.uni-bielefeld.de/scs/aaambos/aaambos_pkg_simple_flexdiam@main
```

### Extended `create` command
Simple flexdiam extends the [`create` command](/docs/create) for the creation of
- `issue`
- `observer`
- `tier`
- `xmit`

Via the `-n`/`--name` argument you can define the name of the created class. The default is `Example*` (`*` => Issue, Observer, ...).
The all options create a new python file.

An example call would be
```bash title="conda activate aaambos"
aaambos create issue -n MyNewIssue
```


<DocCardList />




